init python:
    # Define the LewdScene class to handle background, animations, and sounds with timings.
    class LewdScene:
        def __init__(self, background, image_name, sound_timings):
            self.background = background
            self.image_name = image_name
            self.sound_timings = sound_timings  # Dictionary with speed keys and timing details

        def play_sound(self, speed):
            if speed == 'idle':
                renpy.music.play(self.sound_timings[speed], channel="lewd_sound", relative_volume=1.5)
                #renpy.music.stop("moans")
            if speed == 'slow':
                renpy.music.play(self.sound_timings[speed], channel="lewd_sound", relative_volume=1.5)
                #renpy.music.play(self.moans_1, "moans", relative_volume = self.moans_volume)
            elif speed == 'medium':
                renpy.music.play(self.sound_timings[speed], channel="lewd_sound", relative_volume=1)
                #renpy.music.play(self.moans_2, "moans", relative_volume = self.moans_volume)
            elif speed == 'fast':
                renpy.music.play(self.sound_timings[speed], channel="lewd_sound", relative_volume=1)
            elif speed == 'insert':
                renpy.music.play(self.sound_timings[speed], channel="lewd_sound", relative_volume=1)
                #renpy.music.play(self.moans_3, "moans", relative_volume = self.moans_volume)
            elif speed == 'cum':
                renpy.music.play(self.sound_timings[speed], channel="lewd_sound", relative_volume=1,loop=False)





    SCENE_CONFIGS = {
        "mirko_doggy": LewdScene(
            background="inn room_1_day_mirko",
            image_name="mirko_doggy",
            sound_timings={
                "idle": ["<from 0.0 to 0.3>silence.mp3"],
                "slow": (["<from 0.0 to 0.8>silence.mp3", "<from 0 to 1.217>/lewd_sound/slap.wav"]),
                "medium": ["<from 0.0 to 0.4>silence.mp3", "<from 0 to 0.617>/lewd_sound/slap.wav", "<from 0.0 to 0.4>silence.mp3", "<from 0 to 0.600>/lewd_sound/slap.wav"],
                "fast": ["<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav"],
                "cum": ["<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0 to 0.733>/lewd_sound/cum.mp3", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.733>/lewd_sound/cum.mp3"],
            },
        ),
        "frieren_christmas": LewdScene(
            background="inn room_1_day_mirko",
            image_name="frieren_christmas",
            sound_timings={
                "idle": ["<from 0.0 to 1.5>silence.mp3", "<from 0 to 1.5>/lewd_sound/suck.mp3"],
                "slow": ["<from 0.0 to 0.5>silence.mp3", "<from 0 to 0.5>/lewd_sound/suck.mp3"],
                "medium": ["<from 0.0 to 0.25>silence.mp3", "<from 0 to 0.25>/lewd_sound/suck.mp3"],
                "fast": ["<from 0.0 to 0.05>silence.mp3", "<from 0 to 0.284>/lewd_sound/suck.mp3"],
                "cum": ["<from 0.0 to 0.5>silence.mp3", "<from 0 to 0.5>/lewd_sound/cum.mp3","<from 0.0 to 6.0>silence.mp3"],
            },
        ),
        "zelda_doggy": LewdScene(
            background="inn room_1_day_mirko",
            image_name="zelda_doggy",
            sound_timings={
                "idle": ["<from 0.0 to 0.3>silence.mp3"],
                "insert": ["<from 0.0 to 0.3>silence.mp3", "<from 0 to 1.217>/lewd_sound/slap.wav","<from 0.0 to 3.5>silence.mp3"],
                "slow": (["<from 0.0 to 0.5>silence.mp3", "<from 0 to 1.0085>/lewd_sound/slap.wav"]),
                "medium": ["<from 0.0 to 0.4>silence.mp3", "<from 0 to 0.6085>/lewd_sound/slap.wav"],
                "fast": ["<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.4585>/lewd_sound/slap.wav"],
                "cum": ["<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav", "<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/slap.wav","<from 0.0 to 0.3>silence.mp3", "<from 0 to 0.372>/lewd_sound/cum.mp3","<from 0.0 to 1.2>silence.mp3", "<from 0 to 0.372>/lewd_sound/cum.mp3","<from 0.0 to 1.0>silence.mp3"],
            },
        ),
        "zelda_bj": LewdScene(
            background="inn room_1_day_mirko",
            image_name="zelda_bj",
            sound_timings={
                "idle": ["<from 0.0 to 0.3>silence.mp3"],
                "insert": ["<from 0.0 to 0.3>silence.mp3"],
                "slow": ["<from 0.0 to 0.3>silence.mp3"],
                "medium": ["<from 0.0 to 0.3>silence.mp3"],
                "fast": ["<from 0.0 to 0.3>silence.mp3"],
                "cum": ["<from 0.0 to 0.3>silence.mp3"],
            },
        ),
    }


init python:
    renpy.music.register_channel("lewd_sound", "music")
    renpy.music.register_channel("cum_sound", "music")
    renpy.music.register_channel("moans", "music")
    import itertools

default lewd_sens = True

# Speed Buttons
default xalgin_value = 0.0
screen lewd_speed_buttons(speed,yalign_value,xalgin_value=0):
    zorder 1
    if not quick_menu:
        button:
            sensitive lewd_sens
            xalign xalgin_value
            yalign yalign_value
            image im.Scale(f"/icons/{speed}.png", 200, 200)
            focus_mask True
            action [
                SetVariable("lewd_speed", speed),
                Function(active_scene.play_sound, speed)
            ]

screen lewd_end():
    zorder 1
    if not quick_menu:
        button:
            sensitive lewd_sens
            xalign 0.08
            yalign 0.87
            focus_mask True
            image im.Scale("images/icons/end.png",200,200)
            action Call("LewdEnd")

screen lewd_pause():
    zorder 1
    if not quick_menu:
        button:
            sensitive lewd_sens
            xalign 0.0
            yalign 0.0
            focus_mask True
            image im.Scale("/icons/pause.png", 200, 200)
            action SetVariable("lewd_speed", "idle"), Function(active_scene.play_sound, "idle")

screen lewd_slow():
    use lewd_speed_buttons("slow", 0.25)

screen lewd_medium():
    use lewd_speed_buttons("medium", 0.5)

screen lewd_fast():
    use lewd_speed_buttons("fast", 0.75)
screen lewd_insert():
    use lewd_speed_buttons("insert", 0.12,0.08)

screen lewd_cum():
    zorder 1
    if not quick_menu:
        button:
            sensitive lewd_sens
            xalign 0.0
            yalign 1.0
            focus_mask True
            image im.Scale("/icons/cum.png", 200, 200)
            action SetVariable("lewd_speed", "cum"), Call('LewdCum')

# Screen for H-Scene
screen h_scene():
    # Display the current animation dynamically
    if active_scene:
        add f"{active_scene.image_name} {lewd_speed}"  # Dynamically show the animation based on speed
    else:
        text "No active scene"  # Fallback in case of no scene

# Main interaction'
default lewd_scene = "mirko_doggy"
label ShowLewdScene(scene_name=lewd_scene, speed="slow"):
    hide screen map
    $ quick_menu = False
    stop music
    window hide
    $ active_scene = SCENE_CONFIGS.get(scene_name)
    if not active_scene:
        return

    # Set the initial background
    show expression active_scene.background

    # Initialize the speed and play the corresponding animation and sound
    $ lewd_speed = speed
    $ active_scene.play_sound(lewd_speed)

    # Display the main H-scene screen
    show screen h_scene
    
    # Display buttons for interaction
    show screen lewd_end
    show screen lewd_pause
    show screen lewd_slow
    show screen lewd_medium
    show screen lewd_fast
    show screen lewd_cum
    if active_scene.image_name== "zelda_doggy":
        show screen lewd_insert

    # Wait for user interaction through buttons
    $ ui.interact()

    return


# Cum Label
default cum_counter = 0
label LewdCum:
    $ lewd_sens = False
    $ cum_counter += 1
    $ active_scene.play_sound("cum")
    if lewd_scene == "mirko_doggy":
        $ mirko_data["doggy"] += 1
        $ quests["3"]["value"] += 1
        $ renpy.pause(10.017, hard=True)
    elif lewd_scene == "frieren_christmas":
        $ frieren_data["christmas"] += 1
        $ quests["4"]["value"] += 1
        $ renpy.pause(7.0,hard=True)
    elif lewd_scene == "zelda_doggy":
        $ zelda_data["doggy"] += 1
        $ quests["5"]["value"] += 1
        $ renpy.pause(10.017,hard=True)
    elif lewd_scene == "zelda_bj":
        $ zelda_data["bj"] += 1
        $ quests["6"]["value"] += 1
        $ renpy.pause(3,hard=True)
    #stop lewd_sound
    #$ lewd_speed = "idle"
    $ lewd_sens = True
    $ ui.interact()
    return



label LewdEnd:
    # sounds
    stop lewd_sound
    stop moans

    # screens
    hide screen h_scene
    hide screen lewd_end
    hide screen lewd_pause
    hide screen lewd_slow
    hide screen lewd_medium
    hide screen lewd_fast
    hide screen lewd_cum
    hide screen lewd_insert

    
    $ quick_menu = True
    $ sens = True
    call music_main from _call_music_main
    hide screen quests
    show screen map
    show screen quests
    $ ui.interact()
    return