init python:
    import time

    class msg2:
        def __init__(self, limit=20, delay=5, default_sound="/sounds/level.mp3"):
            self.limit = limit
            self.list = []
            self.idx = 0
            self.delay = delay
            self.default_sound = default_sound

        def msg(self, m, sound=None):
            self.list.append([time.time(), m])
            # Play the specified sound if provided, otherwise play the default sound
            sound_to_play = sound if sound else self.default_sound
            renpy.sound.play(sound_to_play)

        def rem(self):
            for i in self.list:
                if i[0] + self.delay < time.time():
                    self.list.pop(0)
                else:
                    break

default msg = msg2(30)

init python:
    config.overlay_screens.append('notif')

transform notif_t(t):
    alpha 0
    ease .2 alpha 1
    # pause t-1
    # ease .2 alpha 0 yzoom 0

screen notif:
    zorder 2000

    if len(msg.list):
        timer .2 repeat True action Function(msg.rem)
    vbox:
        xalign 0.0
        yalign 0.0 yoffset 300
        xmaximum 600
        spacing 10
        for i in msg.list:
            frame:
                at notif_t(msg.delay)
                maximum(600, 1000)
                style "game_over_frame"
                align (0.0, 0.02)
                vbox:
                    xalign 0.0
                    text "{}".format(i[1]) color "#ffff"


style game_over_frame:
    background "#000000dd"
    padding (20, 20)