label quest_1:
    $ sens = False
    show screen quest_1
    "It's been a long time, but I'm finally back."
    "First of all I need to find my Inn."
    show screen quests
    window hide
    $ sens = True

    $ ui.interact()
    return

image map day2:
    "images/map/village_day.png"
default inn_blinking = True
screen quest_1:
    add "map day2"
    
    # Timer to toggle the blinking state
    timer 10 repeat True action SetVariable("inn_blinking", not inn_blinking)

    # Use a ConditionSwitch to alternate between visible and invisible states
    imagebutton:
        idle ConditionSwitch(
            inn_blinking, "images/map/inn_day.png",
            not inn_blinking, "inn_day_blink"
        )
        hover (im.MatrixColor("images/map/inn_day.png", im.matrix.brightness(0.3)))
        sensitive sens
        focus_mask True
        action Hide("quest_1"),Hide("quests"), SetVariable("sens", False), Call("chapter_1")
    

    imagebutton:
        idle "images/map/mirko_day.png"
        hover (im.MatrixColor("images/map/mirko_day.png", im.matrix.brightness(0.3)))
        sensitive sens
        focus_mask True
        action Call("quest_1_false")


image inn_day_blink:
    "images/map/inn_day.png" 
    pause 0.5 
    (im.MatrixColor("images/map/inn_day.png", im.matrix.brightness(0.3))) 
    pause 0.5 
    repeat

label quest_1_false:
    "Seems like it's not my Inn."
    window hide
    $ ui.interact()
    return


label chapter_1:
    # sound: door open
    show inn floor_1_day with dissolve
    "I open the door and I'm surprised by the lack of dust."

    show aya at half_sprite_center
    with dissolve
    aya shocked "Y-You're back!{w} I-I can't believe it… "

    "She runs up to me and gives me a hug."

    aya tears "You're really here… I've waited… for years… "

    "I can feel tears wetting my shirt.{w} She really missed me… "

    mc "Aya, I'm sorry for taking so long.{w} I see you're still taking care of the place."

    aya smile_tears "O-Of course, I knew you would come back.{w} I just… didn't know when… How was… the outside world?"

    mc "Dull, that's why I'm back.{w} But I can see the place has seen better days.{w} I don't even see the star attractions."

    aya tears_look_away "Well, you weren't here.{w} It was hard to keep the 'Waifus' here after you left."

    aya smile_tears "Right now, we're just a normal inn."

    mc "More like an abandoned one.{w} That means I have to start from scratch.{w} Good, I like a challenge.{w} Take care of the place a little longer, I'll be back when I find a new sex worker."

    aya "Okay… please don't take too long."

    "I leave the inn to search the village for some willing women."

    return



