label quest_2:
    $ sens = False
    show screen quest_2
    "Well, now I need to find her house."
    $ sens = True
    show screen quests
    window hide

    $ ui.interact()
    return


default mirko_blinking = True

screen quest_2:
    add "map day2"

    # Timer to toggle the blinking state for the Mirko icon
    timer 10 repeat True action SetVariable("mirko_blinking", not mirko_blinking)

    # Use ConditionSwitch for blinking Mirko icon
    imagebutton:
        idle ConditionSwitch(
            mirko_blinking, "images/map/mirko_day.png",
            not mirko_blinking, "mirko_day_blink"
        )
        hover (im.MatrixColor("images/map/mirko_day.png", im.matrix.brightness(0.3)))
        sensitive sens
        focus_mask True
        action Hide("quest_2"),Hide("quests"), SetVariable("sens", False), Call("chapter_2")

# Define the blinking image for Mirko
image mirko_day_blink:
    "images/map/mirko_day.png"
    pause 0.5
    (im.MatrixColor("images/map/mirko_day.png", im.matrix.brightness(0.3)))
    pause 0.5
    repeat


# Manga  
image mirko_ch_2_shocked:
    "images/chapters/2/1.png"
    xpos 1050
    yalign 0.5
    zoom 0.9
image mirko_ch_2_boobs:
    "images/chapters/2/2.png"
    xpos 500
    yalign 0.5
    zoom 0.9
image mirko_ch_2_nipples:
    "images/chapters/2/3.png"
    xpos 1400
    yalign 0.5
    zoom 0.9
image mirko_ch_2_kiss:
    "images/chapters/2/4.png"
    xpos 500
    yalign 0.5
    zoom 0.9
image mirko_ch_2_slap:
    "images/chapters/2/5.png"
    xpos 1400
    yalign 0.5
    zoom 0.9



image dim:
    "#0008"
    zoom 1.1

label chapter_2:
    # {Mirko Meeting]
    # sound: knocking the door
    show mirko_house entrance_day
    with dissolve
    "I knock on the door."

    "I hear some sounds on the other side, after a moment Mirko opens the door."
    
    show mirko 2 at half_sprite_center
    with dissolve
    pause 1.5
    mirko "… Well, well, look who came back."

    mc "Hello Mirko."

    mirko "Why are you here?"

    mc "Can I come in first?"

    mirko "I don't think so, we can talk out here."

    mc "… Fine, I plan on reopening the Waifu Inn and I want you there."

    show mirko base at half_sprite_center
    with dissolve
    pause 1.5
    mirko "Mmmm, I wouldn't mind that.{w} But… I have some conditions."

    mc "Name them."

    mirko "Since I'm the first and you clearly need me, I want higher pay and fewer hours."

    mc "… excuse me?"
    
    show mirko 4 at bottom_to_top_zoom
    with dissolve
    $ renpy.pause(8.0,hard=True)
    show mirko 4 at half_sprite_center
    with dissolve
    pause 1.5
    mirko "You heard me.{w} You want this body to work for you again?{w} You have to pay up and give me more free time."

    mc "...{w} I bet it's been boring without me."

    mirko "..."

    mc "I remember you used to come each night to my room when noone could satisfy you as I could."

    mirko "You can't just offer me better fuck."

    mc "I'll take good care of you this time."

    mirko "..."

    mirko "Will you?{w} ... {w} I mean, no!"

    mc "Well, seems like I can't reassure you.{w} That's fine."

    mirko "..."

    mc "Such a loss for our Inn, you were our star back then."

    mirko "..."

    mc "Bye."

    mirko "...{w} Wait! {w}You!{w} I hate you."

    mc "Huh?"

    mirko "You better keep your words!"

    mc "Of couse I will"

    mirko "Tonight..."

    mc "What?"

    mirko "I said tonight!{w} Don't make me regret my choice.{w} You better take good care of me.{w} Starting today!{w} Hahaha"

    mirko "The Inn will be reminded who was the main Waifu there!"

    mc "Glad you're back, Mirko."

    mirko "Who else would lift your miserable exsitence.{w} Hahaha"

    mc "Sure."
    return