default sens = False
default Patreon = False
default itch = True
default Cheats = False

# Define quests as a dictionary
default quests = {
    "1": {"active": True, "description": "Find your Inn"},
    "2": {"active": False, "description": "Find Mirko's house"},
    "3": {"active": False, "description": "Creampie Mirko", "value": 0,"goal": 3, "completed": False},
    "4": {"active": False, "description": "Creampie Frieren", "value": 0,"goal": 3, "completed": False},
    "5": {"active": False, "description": "Creampie Zelda", "value": 0,"goal": 3, "completed": False},
    "6": {"active": False, "description": "Check how Zelda does blowjob","goal": 3, "value": 0, "completed": False},
    "7": {"active": False, "description": "Coming soon...", "value": 0,"goal": 1, "completed": False},
}
# Example Aya-specific data
default mirko_data = {
    "chapters": [
        {"image": "images/animations/mirko/doggy/cover.png", "name": "CHAPTER 1", "link": "quest_1", "unlocked": True, "scene":"mirko_doggy","lewd_name": "DOGGY", "Patreon": False},
        #{"image": "images/chapters/3/1.png", "name": "CHAPTER 2", "link": "quest_2", "unlocked": Patreon, "scene":"mirko_doggy","lewd_name": "DOGGY"},
    ],
    "num_columns": 5,
    "x_padding": 20,
    "text_size": 30,
    "x_max": 300,
    "y_max": 960,
    "image_width": 640,  # Define the actual image width
    "image_height": 1080,  # Define the actual image height
    "doggy": 0
}
default frieren_data = {
    "chapters": [
        {"image": "images/animations/frieren/Christmas/cum.png", "name": "CHAPTER 1", "link": "quest_1", "unlocked": False, "scene":"frieren_christmas","lewd_name": "CHRISTMAS", "Patreon": False},
        #{"image": "images/chapters/4/ch_4.png", "name": "CHAPTER 2", "link": "quest_2", "unlocked": battle_levels[2]["active"]},
    ],
    "num_columns": 5,
    "x_padding": 20,
    "text_size": 30,
    "x_max": 300,
    "y_max": 960,
    "image_width": 640,  # Define the actual image width
    "image_height": 1080,  # Define the actual image height
    "christmas": 0
}

default zelda_data = {
    "chapters": [
        {"image": "images/animations/zelda/doggy/cum.png", "name": "CHAPTER 1", "link": "quest_1", "unlocked": False, "scene":"zelda_doggy","lewd_name": "DOGGY", "Patreon": False},
        {"image": "images/animations/zelda/bj/cover.png", "name": "CHAPTER 2", "link": "quest_1", "unlocked": False, "scene":"zelda_bj","lewd_name": "BLOWJOB", "Patreon": True},
    ],
    "num_columns": 5,
    "x_padding": 20,
    "text_size": 30,
    "x_max": 300,
    "y_max": 960,
    "image_width": 640,  # Define the actual image width
    "image_height": 1080,  # Define the actual image height
    "doggy": 0,
    "bj": 0
}


# Screen to display active quests
screen quests:
    modal False
    frame:
        maximum (400, 300)  # Adjust the size
        style "game_over_frame"
        align (0.02, 0.02)

        hbox:
            spacing 20
            xalign 0.5
            # Iterate through the quests dictionary
            for quest, details in quests.items():
                if details["active"] and details["description"]:
                    text "[details['description']]"
                    if "value" in details:
                        text "[details['value']]/[details['goal']]" align (0.5,0.5)



style game_over_frame:
    background "#000000da"
    padding (20, 20)


label quest_gate:
    $ active_quest = next((q for q in quests.values() if q["active"]), None)
    
    if active_quest:
        "First you need to [active_quest['description']]"
    else:
        "There are no active quests."

    window hide
    call main_screen from _call_main_screen_1
    return

label main_screen:
    $ sens = True
    show screen map
    show screen quests
    $ ui.interact()
    return

init python:
    def quest_check():
        global quests, mirko_data

        # Find the first active quest
        active_quest = next((q for q in quests.values() if q["active"]), None)

        if active_quest:
            quest_id = next((qid for qid, q in quests.items() if q == active_quest), None)

            # Check if quest is "Creampie Mirko" and if the condition is met
            if quest_id == "3" and active_quest["value"] >= active_quest["goal"]:
                quest_update(quest_id)
                msg.msg("Quest completed")
                frieren_data["chapters"][0]["unlocked"] = True
            if quest_id == "4" and active_quest["value"] >= active_quest["goal"]:
                quest_update(quest_id)
                msg.msg("Quest completed")
                zelda_data["chapters"][0]["unlocked"] = True
            if quest_id == "5" and active_quest["value"] >= active_quest["goal"]:
                quest_update(quest_id)
                msg.msg("Quest completed")
                zelda_data["chapters"][1]["unlocked"] = True
            if quest_id == "6" and active_quest["value"] >= active_quest["goal"]:
                quest_update(quest_id)
                msg.msg("Quest completed")

    def quest_update(active_q_id):
        global quests

        if active_q_id in quests:
            quests[active_q_id]["active"] = False
            quests[active_q_id]["completed"] = True

            # Find the next quest in order
            next_q_id = str(int(active_q_id) + 1)
            if next_q_id in quests:
                quests[next_q_id]["active"] = True
